javax.resource.spi

## Interface ResourceAdapter

-     public interface ResourceAdapter

  This represents a resource adapter instance and contains operations for lifecycle management and message endpoint setup. A concrete implementation of this interface is required to be a JavaBean.
  Version:
    1.0
  Author:
    Ram Jeyaraman

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `endpointActivation(MessageEndpointFactory endpointFactory, ActivationSpec spec)` This is called during the activation of a message endpoint.
    `void` | `endpointDeactivation(MessageEndpointFactory endpointFactory, ActivationSpec spec)` This is called when a message endpoint is deactivated.
    `javax.transaction.xa.XAResource[]` | `getXAResources(ActivationSpec[] specs)` This method is called by the application server during crash recovery.
    `void` | `start(BootstrapContext ctx)` This is called when a resource adapter instance is bootstrapped.
    `void` | `stop()` This is called when a resource adapter instance is undeployed or during application server shutdown.

- - ### Method Detail

    - #### start

          void start(BootstrapContext ctx)
              throws ResourceAdapterInternalException

      This is called when a resource adapter instance is bootstrapped. This may be during resource adapter deployment or application server startup. This is a startup notification from the application server, and this method is called by an application server thread. The application server thread executes in an unspecified context.

      During this method call a ResourceAdapter JavaBean is responsible for initializing the resource adapter instance. Any exception thrown during this method call causes the application server to abort the bootstrap procedure for this specific resource adapter instance.

      Parameters:
        `ctx` - a bootstrap context containing references to useful facilities that could be used by a resource adapter instance.
      Throws:
        `ResourceAdapterInternalException` - indicates bootstrap failure. The resource adapter instance is unusable and must be discarded.

    - #### stop

          void stop()

      This is called when a resource adapter instance is undeployed or during application server shutdown. This is a shutdown notification from the application server, and this method is called by an application server thread. The application server thread executes in an unspecified context.

      During this method call, a ResourceAdapter JavaBean is responsible for performing an orderly shutdown of the resource adapter instance. Any exception thrown by this method call does not alter the processing of the application server shutdown or resource adapter undeployment that caused this method call. The application server may log the exception information for error reporting purposes.

    - #### endpointActivation

          void endpointActivation(MessageEndpointFactory endpointFactory,
                                  ActivationSpec spec)
                           throws ResourceException

      This is called during the activation of a message endpoint. This causes the resource adapter instance to do the necessary setup (ie., setup message delivery for the message endpoint with a message provider). Note that message delivery to the message endpoint might start even before this method returns.

      Endpoint activation is deemed successful only when this method completes successfully without throwing any exceptions.

      Parameters:
        `endpointFactory` - a message endpoint factory instance.
        `spec` - an activation spec JavaBean instance.
      Throws:
        `ResourceException` - Thrown if an error occurs
        `NotSupportedException` - indicates message endpoint activation rejection due to incorrect activation setup information.

    - #### endpointDeactivation

          void endpointDeactivation(MessageEndpointFactory endpointFactory,
                                    ActivationSpec spec)

      This is called when a message endpoint is deactivated. The instances passed as arguments to this method call should be identical to those passed in for the corresponding endpointActivation call. This causes the resource adapter to stop delivering messages to the message endpoint.

      Any exception thrown by this method is ignored. After this method call, the endpoint is deemed inactive.

      Parameters:
        `endpointFactory` - a message endpoint factory instance.
        `spec` - an activation spec JavaBean instance.

    - #### getXAResources

          javax.transaction.xa.XAResource[] getXAResources(ActivationSpec[] specs)
                                                    throws ResourceException

      This method is called by the application server during crash recovery. This method takes in an array of `ActivationSpec` JavaBeans and returns an array of `XAResource` objects each of which represents a unique resource manager. The resource adapter may return null if it does not implement the `XAResource` interface. Otherwise, it must return an array of `XAResource` objects, each of which represents a unique resource manager that was used by the endpoint applications. The application server uses the `XAResource` objects to query each resource manager for a list of in-doubt transactions. It then completes each pending transaction by sending the commit decision to the participating resource managers.
      Parameters:
        `specs` - an array of `ActivationSpec` JavaBeans each of which corresponds to an deployed endpoint application that was active prior to the system crash.
      Returns:
        an array of `XAResource` objects each of which represents a unique resource manager.
      Throws:
        `ResourceException` - generic exception if operation fails due to an error condition.

Copyright © 2014 IronJacamar (http://www.ironjacamar.org)